/**
 * 广告是否在当前屏幕显示
 */
TencentNewsScriptController.detectIsShow = false;

TencentNewsScriptController.isIabPing = false;
TencentNewsScriptController.isIabPinged = false;
TencentNewsScriptController.isTiming = false;
TencentNewsScriptController.impDuration = 10 * 100;
TencentNewsScriptController.impRatio = 50;

TencentNewsScriptController.webviewWidth = 720;
TencentNewsScriptController.webviewHeight = 1090;

function initScreenParams(width, height) {
    TencentNewsScriptController.webviewWidth = width;
    TencentNewsScriptController.webviewHeight = height;
};

TencentNewsScriptController.getElementViewTop = function(element) {
	var actualTop = element.offsetTop;
	var current = element.offsetParent;
	while (current !== null) {
		actualTop += current.offsetTop;
		current = current.offsetParent;
	}

	if (document.compatMode == "BackCompat") {
		var elementScrollTop = document.body.scrollTop;
	} else {
		var elementScrollTop = document.documentElement.scrollTop;
	}

	return actualTop - elementScrollTop;
}

function setAdvertExpParamForWebDetail(duration, ratio) {
	TencentNewsScriptController.isIabPing = true;
	TencentNewsScriptController.impDuration = duration * 100;
	TencentNewsScriptController.impRatio = ratio;
};

/**
 * 自媒体广告插入 for WebDetailActivity
 */
function insertWMAdvert(opentype, adsubtype, imgurl, text, icon, extraIcon, actType) {
	var adDiv = document.getElementById("newsAD");
	var html = [];

	if (adsubtype == 13 || adsubtype == 14) { // 13：大图，14：文字链
		html.push('<div class="ad_divider">');
		html.push('<p>赞助商提供</p>');
		html.push('</div>');
	} else {
		// console.log("insert blank");
		html.push('<hr class="ad_divider" color="black" style="margin:0px; border-top:0px; visibility:hidden"/>')
		html.push('<hr class="ad_blank" color="black" style="margin:0px; border-top:0px; visibility:hidden"/>');
	}

	if (adsubtype == 14 && text != "") {
		if (window.TencentNewsScriptControllerJsInterface && window.TencentNewsScriptControllerJsInterface.startWMAdvertActivity) {
			var iconTxt = "<div></div>";
			html.push('<a onClick = "window.TencentNewsScriptControllerJsInterface.startWMAdvertActivity()">' + iconTxt + '<span class="text">' + text + '</span></a>');
		}
	} else if (adsubtype == 13 && imgurl != "") {
		html.push('<div class="ad_icon show">');
		if (actType != 1) {
            if (opentype == 1) {
                html.push('<div class="ad_flag">');
                html.push('</div>');
            } else if (opentype == 2 || (opentype == 0 && actType == 2)) {
                html.push('<div class="ad_flag">');
                html.push('</div>');
            }
		}
		if (extraIcon != "" && actType == 1) {
           	html.push('<div class="ad_download_flag">');
            html.push('</div>');
        }
		html.push('<div class="ad_tag"></div>');
		html.push('</div>');
		if (window.TencentNewsScriptControllerJsInterface && window.TencentNewsScriptControllerJsInterface.startWMAdvertActivity) {
            html.push('<div class="ad_image">');
            html.push('<img src="'+ imgurl + '" data-url="' + imgurl + '" onClick = "window.TencentNewsScriptControllerJsInterface.startWMAdvertActivity()"/>');
		}
		html.push('</div>');
	}
	if(html.length >0) {
		adDiv.style.display = "block";
		adDiv.innerHTML = html.join('');
	}

	TencentNewsScriptController.detectAdIsShow();
};

/**
 * 检测广告是否展示，如果广告展示就去上报曝光
 */
TencentNewsScriptController.detectAdIsShow = function() {
    var viewH = document.documentElement.clientHeight;
    var scrollTop = Math.max(document.documentElement.scrollTop, document.body.scrollTop);
    if (viewH == 0) {
        viewH = TencentNewsScriptController.webviewHeight / window.devicePixelRatio;
    }
    var divNode = document.querySelector('#newsAD .ad_divider');
//    console.log(divNode);
    if (!divNode) {
        return;
    } else {
//        console.log("isIabPing: " + TencentNewsScriptController.isIabPing);
        if (!TencentNewsScriptController.isIabPing) {
            var imgViewTop = TencentNewsScriptController.getElementViewTop(divNode);
            var middleView = imgViewTop + divNode.offsetHeight / 2;
            if ((middleView > scrollTop) && middleView < (viewH + scrollTop)) {
                if (window.TencentNewsScriptControllerJsInterface && window.TencentNewsScriptControllerJsInterface.adShowTimes && !TencentNewsScriptController.detectIsShow) {
//                    console.log("method adShowTimes found in native code");
                    window.TencentNewsScriptControllerJsInterface.adShowTimes();
                    TencentNewsScriptController.detectIsShow = true;
                }
            } else {
                TencentNewsScriptController.detectIsShow = false;
            }
            getDetectIsShowInJs();
        } else {
            if (TencentNewsScriptController.isIabPinged) {
                return;
            }
            var imgViewTimer = new Object();
            var imgViewTop = TencentNewsScriptController.getElementViewTop(divNode);
            var imgViewBottom = imgViewTop + divNode.offsetHeight;
            var imgNode = document.querySelector('#newsAD .ad_image');
            if (imgNode) {
                var imgNodeBottom = TencentNewsScriptController.getElementViewTop(imgNode) + imgNode.offsetHeight;
                imgViewBottom = imgViewBottom >= imgNodeBottom ? imgViewBottom : imgNodeBottom;
            }
            var textNode = document.querySelector('#newsAD .text');
            if (textNode) {
                var textNodeBottom = TencentNewsScriptController.getElementViewTop(textNode) + textNode.offsetHeight;
                imgViewBottom = imgViewBottom >= textNodeBottom ? imgViewBottom : textNodeBottom;
            }
            var imgViewDetect = -1;
//            console.log("scrollTop: " + scrollTop + " viewH: " + viewH);
//            console.log("imgViewBottom: " + imgViewBottom + " imgViewTop: " + imgViewTop);
            if (imgViewBottom > scrollTop && imgViewBottom <= scrollTop + viewH) {
                imgViewDetect = imgViewBottom - (imgViewBottom - imgViewTop) * TencentNewsScriptController.impRatio / 100;
            } else if (imgViewTop >= scrollTop && imgViewTop < scrollTop + viewH) {
                imgViewDetect = imgViewTop + (imgViewBottom - imgViewTop) * TencentNewsScriptController.impRatio / 100;
            }
//            console.log("imgViewDetect: " + imgViewDetect);
            if (imgViewDetect != -1 && imgViewDetect >= scrollTop && imgViewDetect <= scrollTop + viewH) {
                TencentNewsScriptController.detectIsShow = true;
                if (TencentNewsScriptController.impDuration == 0) {
                    if (window.TencentNewsScriptControllerJsInterface && window.TencentNewsScriptControllerJsInterface.adShowTimes && !TencentNewsScriptController.detectIsShow) {
//                        console.log("method adShowTimes found in native code");
                        window.TencentNewsScriptControllerJsInterface.adShowTimes();
                        TencentNewsScriptController.isIabPinged = true;
                        getDetectIsShowInJs();
                    }
                } else {
//                    console.log("isTiming: " + TencentNewsScriptController.isTiming);
                    if (!TencentNewsScriptController.isTiming) {
                        TencentNewsScriptController.isTiming = true;
                        imgViewTimer = setTimeout(function(){getDetectIabIsShow()}, TencentNewsScriptController.impDuration);
                    }
                }
            } else {
                TencentNewsScriptController.detectIsShow = false;
                if (TencentNewsScriptController.isTiming) {
                    clearTimeout(imgViewTimer);
                    TencentNewsScriptController.isTiming = false;
                }
                imgViewTimer = null;
            }
        }
    }
};

function getDetectIabIsShow() {
//	console.log("isIabShow: " + TencentNewsScriptController.detectIsShow);
	if (TencentNewsScriptController.detectIsShow) {
		if (window.TencentNewsScriptControllerJsInterface && window.TencentNewsScriptControllerJsInterface.getDetectIsShow) {
//		    console.log("method getDetectIsShow found in native code");
			TencentNewsScriptController.isIabPinged = true;
			window.TencentNewsScriptControllerJsInterface.getDetectIsShow("true");
		}
	}
}

function getDetectIsShowInJs() {
//    console.log("isViewShow: " + TencentNewsScriptController.detectIsShow);
	var isShow = TencentNewsScriptController.detectIsShow;
	if (window.TencentNewsScriptControllerJsInterface && window.TencentNewsScriptControllerJsInterface.getDetectIsShow) {
//	    console.log("method getDetectIsShow found in native code");
		window.TencentNewsScriptControllerJsInterface.getDetectIsShow(isShow.toString());
	}
}