package com.tencent.httpproxy.aidl;
import com.tencent.httpproxy.aidl.IAdvDownloadListenerAIDL;
import com.tencent.httpproxy.aidl.IPlayListenerAIDL;
import com.tencent.httpproxy.aidl.IPrepareListenerAIDL;
import com.tencent.httpproxy.aidl.ITimecostReportAIDL;

interface IPlayManagerAIDL
{
    oneway void setPlayCapacity(int capacity);

	int startOnlineOrOfflinePlay(int dlType, String cid, String vid,
										String format, boolean isCharge, boolean isDrm, int useCacheFlag, in IPlayListenerAIDL listener, in Map extraParamsMap, in Map requestExtParamsMap);

    int startPlayByVinfo(int playId, int dlType, String cid, String vid, String format, in IPlayListenerAIDL listener, in Map extraParamsMap, String vinfo);

	int getDlnaUrl(int dlType, String cid, String vid,
						  String format, boolean isCharge, boolean isDrm, String upc, in Map extraParamsMap);

    String startAdvPlay(String playInfoXML);

	oneway void stopPlay(int playId);

    oneway void prepareMP4(int playId);

	String buildPlayURLMP4(int playId, boolean forceOnline);

	String[] buildPlayURLMP4Back(int playId);

	String buildCaptureImageURLMP4(int playId, boolean forceOnline);

	int getErrorCode(int playId);

	boolean isLocalVideo(int playId);

    long getCurrentOffset(int playId);

	long getTotalOffset(int playId);

	oneway void setAdvDownloadListener(in IAdvDownloadListenerAIDL listener);

	void setPlayListener(in IPlayListenerAIDL listener);

	oneway void setPrepareListener(in IPrepareListenerAIDL listener);

	ITimecostReportAIDL getTimecostReport(int playId);

	oneway void setCookie(String cookie);

	oneway void setOpenApi(String openId, String accessToken,
						   String oauthConsumeKey, String pf);

	int getDWType();

	int setNextVid(String vid, String format, boolean isCharge, boolean isNewFirst, boolean isHotSpot, long startTime, long endTime, in Map requestExtParamsMap);

    int setNextVidByVinfo(int playId, String vid, String format, boolean isCharge, boolean isNewFirst, boolean isHotSpot, long startTime, long endTime, in Map requestExtParamsMap, String vinfoStr);

	int setErrorCode(int playId, int errorCode);

	int startLivePlay(String programId, String pid, String urls,
							 int type, String vinfoJson);

	oneway void stopLivePlay(int playId) ;

	int setLiveLibraryPath(String path);

	oneway void setMaxUseMemory(int memorySize);

	String getCurrentPlayURL();

	String getCurrentPlayCDNURL(int playId);

	oneway void pauseDownloadOn3G();

	oneway void resumeDownloadOn3G();

	int StartPlayByUrl(int playID, int dlType, int taskType, String vid, String format, int duration, boolean ischarge, String guid, int startTime, int endTime, String url);

	int setNextVidByUrl(int dlType, int taskType, String vid, String format, int duration, boolean isCharge, String guid, String url);

	int GetDownloadSpeed(int dDataID, int type);

	oneway void setUserData(in Map userDataMap);

    oneway void deinit();

    oneway void setIsVip(boolean IsVip);

    oneway void setServerConfig(String serverConfig);

    int getCkeyVer();

    String getCurrentVersion();

    oneway void pushEvent(int event);

    oneway void appToBack();

    oneway void appToFront();

    boolean isExistP2P();

    boolean isOfflineRecord(String vid, String format);

    int getRecordDuration(String vid, String format);

    long getCurrentDuration(int playId);

    boolean isPermitForceOnline(int playId);

	oneway void setUpc(String upc);

	oneway void setModuleUpdateP2PVersion(String version);

	oneway void setPlayingState(int playId, int state);

	oneway void setUpdateModleServerConfig(String serverConfig);

	String getPlayInfo(int playId, String keyStr);

    String getPlayErrorCodeStr(int playId);

    int getAppCurrentSpeed();

    int getPlayPropertyInfo(int playId, int propertyId);

    void setPlayInfo(int playId, String keyStr, String value);

    boolean isCanDownloadAndPlay(String vid, String format);

    String getSubTitlePath(int playId, String subTitleKeyId);

    long getPlayCacheSizeKB(String vid, String format);
}